#ifndef DUNE_RAVIARTTHOMASBASIS_HH
#define DUNE_RAVIARTTHOMASBASIS_HH

#include <fstream>
#include <dune/common/exceptions.hh>

#include <dune/localfunctions/utility/defaultbasisfactory.hh>
#include <dune/localfunctions/raviartthomas/interpolation.hh>
#include <dune/localfunctions/raviartthomas/raviartthomasprebasis.hh>

namespace Dune
{
  template< unsigned int dim, class SF, class CF >
  struct RaviartThomasBasisFactory
   : public DefaultBasisFactory< RTPreBasisFactory<dim,CF>,
               RaviartThomasL2InterpolationFactory<dim,CF>,
               dim,dim,SF,CF > 
  {
  };
}

#endif // #ifndef DUNE_RAVIARTTHOMASBASIS_HH

